Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## avrora.core.isdl.gen
Class Canonicalizer

    java.lang.Object
      avrora.core.isdl.ast.CodeRebuilder.DepthFirst
          avrora.core.isdl.ast.StmtRebuilder.DepthFirst
              avrora.core.isdl.gen.Canonicalizer

All Implemented Interfaces:
  CodeRebuilder, StmtRebuilder

public class Canonicalizer
extends StmtRebuilder.DepthFirst

Nested Class Summary

Nested classes inherited from class avrora.core.isdl.ast.StmtRebuilder
`StmtRebuilder.DepthFirst`

Constructor Summary
`Canonicalizer()`

Method Summary
`protected Expr` | `liftExpr(Expr e, java.lang.Object env)`
`java.util.LinkedList` | `process(java.util.LinkedList stmts)`
`Expr` | `visit(CallExpr e, java.lang.Object env)`
`Stmt` | `visit(MapAssignStmt e, java.lang.Object env)`
`Stmt` | `visit(MapBitAssignStmt e, java.lang.Object env)`
`Stmt` | `visit(MapBitRangeAssignStmt e, java.lang.Object env)`
`Expr` | `visit(MapExpr e, java.lang.Object env)`

Methods inherited from class avrora.core.isdl.ast.StmtRebuilder.DepthFirst
`addStmt, visit, visit, visit, visit, visit, visit, visit, visit, visitStmtList, visitStmts`

Methods inherited from class avrora.core.isdl.ast.CodeRebuilder.DepthFirst
`visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visitExprList`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface avrora.core.isdl.ast.CodeRebuilder
`visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit`

Constructor Detail

### Canonicalizer

    public Canonicalizer()

Method Detail

### visit

    public Expr visit(MapExpr e,
                      java.lang.Object env)

  Specified by:
    `visit` in interface `CodeRebuilder`
  Overrides:
    `visit` in class `CodeRebuilder.DepthFirst`

### visit

    public Expr visit(CallExpr e,
                      java.lang.Object env)

  Specified by:
    `visit` in interface `CodeRebuilder`
  Overrides:
    `visit` in class `CodeRebuilder.DepthFirst`

### visit

    public Stmt visit(MapAssignStmt e,
                      java.lang.Object env)

  Specified by:
    `visit` in interface `StmtRebuilder`
  Overrides:
    `visit` in class `StmtRebuilder.DepthFirst`

### visit

    public Stmt visit(MapBitAssignStmt e,
                      java.lang.Object env)

  Specified by:
    `visit` in interface `StmtRebuilder`
  Overrides:
    `visit` in class `StmtRebuilder.DepthFirst`

### visit

    public Stmt visit(MapBitRangeAssignStmt e,
                      java.lang.Object env)

  Specified by:
    `visit` in interface `StmtRebuilder`
  Overrides:
    `visit` in class `StmtRebuilder.DepthFirst`

### liftExpr

    protected Expr liftExpr(Expr e,
                            java.lang.Object env)

### process

    public java.util.LinkedList process(java.util.LinkedList stmts)

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD